#include "Affichage.h"

float DmeriParal[51][2];	// For grids drawing optimisation

// precalculation of the grid points
void InitMeriParal(void)
{	for(int j=0;j<51;j++)
	{	DmeriParal[j][1]=cos(j*2*PI/50)*20;
		DmeriParal[j][2]=sin(j*2*PI/50)*20;
	}
}

// Draw the cardinals points : N S E O and Z (Zentih) N (Nadir)
void AfficheCardinaux(void)
{	glPushMatrix();
	glColor3f(0.8f, 0.1f, 0.1f);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBindTexture(GL_TEXTURE_2D,texIds[6]);		//Nord
	glTranslatef(0.0f,0.0f,30.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f( 1.0f,-1.0f,0.0f);	// Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(-1.0f,-1.0f,0.0f);	// Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(-1.0f, 1.0f,0.0f);	// Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f( 1.0f, 1.0f,0.0f);	// Haut Gauche
	glEnd ();

	glBindTexture(GL_TEXTURE_2D, texIds[7]);	//Sud
	glTranslatef(0.0f,0.0f,-60.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-1.0f,-1.0f,0.0f);	// Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f( 1.0f,-1.0f,0.0f);	// Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f( 1.0f, 1.0f,0.0f);	// Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-1.0f, 1.0f,0.0f);	// Haut Gauche
	glEnd ();

	glBindTexture(GL_TEXTURE_2D, texIds[9]);	//Ouest
	glTranslatef(30.0f,0.0f,30.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(0.0f,-1.0f,-1.0f);	// Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(0.0f,-1.0f, 1.0f);	// Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(0.0f, 1.0f, 1.0f);	// Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(0.0f, 1.0f,-1.0f);	// Haut Gauche
	glEnd ();

	glBindTexture(GL_TEXTURE_2D, texIds[8]);	//Est
	glTranslatef(-60.0f,0.0f,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(0.0f,-1.0f, 1.0f);	// Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(0.0f,-1.0f,-1.0f);	// Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(0.0f, 1.0f,-1.0f);	// Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(0.0f, 1.0f, 1.0f);	// Haut Gauche
	glEnd ();

	glBindTexture(GL_TEXTURE_2D, texIds[10]);	//Zenith
	glTranslatef(30.0f,30.0f,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f( 1.0f, 0.0f,-1.0f);	// Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f( 1.0f, 0.0f, 1.0f);	// Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(-1.0f, 0.0f, 1.0f);	// Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-1.0f, 0.0f,-1.0f);	// Haut Gauche
	glEnd ();

	glBindTexture(GL_TEXTURE_2D, texIds[11]);	//Nadir
	glTranslatef(0.0f,-60.0f,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f( 1.0f, 0.0f,-1.0f);	// Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f( 1.0f, 0.0f, 1.0f);	// Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(-1.0f, 0.0f, 1.0f);	// Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-1.0f, 0.0f,-1.0f);	// Haut Gauche
	glEnd ();
	glPopMatrix();
}

// Draw the milky way : used too to 'clear' the buffer
void AfficheVoieLactee(void)
{	glPushMatrix();
	glColor3f(0.02f-coefciel, 0.02f-coefciel, 0.08f-coefciel);
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glBindTexture(GL_TEXTURE_2D, texIds[2]);
	glRotatef(-66,1,0,0);
	glRotatef(-68,0,1,0);
	glRotatef(28,0,0,1);
	GLUquadricObj * VoieLactee=gluNewQuadric();
	gluQuadricTexture(VoieLactee,GL_TRUE);
	gluSphere(VoieLactee,1000,15,15);
	gluDeleteQuadric(VoieLactee);
	glPopMatrix();
}

// Draw the equatorial merididians
void AfficheMeridiens(void)
{	glPushMatrix();	
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	float coef;
	coef=rand();
	coef/=RAND_MAX;
	glColor3f(0.12*coef+0.08,0.015*coef+0.1,0.015*coef+0.1);
	for(int i=0;i<12;i++)
	{	glRotatef(360/24,0,1,0);
		for(int j=0;j<50;j++)
		{	glBegin (GL_LINES);
				glVertex3f(DmeriParal[j][1],DmeriParal[j][2], 0.0f);
				glVertex3f(DmeriParal[j+1][1],DmeriParal[j+1][2], 0.0f);
			glEnd ();
		}
	}
	glPopMatrix();
}

// Draw the azimuthal merididians
void AfficheMeridiensAzimuth(void)
{	glPushMatrix();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	float coef;
	coef=rand();
	coef/=RAND_MAX;
	glColor3f(0.015*coef+0.1,0.12*coef+0.08,0.015*coef+0.1);
	for(int i=0;i<12;i++)
	{	glRotatef(360/24,0,1,0);
		for(int j=0;j<50;j++)
		{	glBegin (GL_LINES);
				glVertex3f(DmeriParal[j][1],DmeriParal[j][2], 0.0f);
				glVertex3f(DmeriParal[j+1][1],DmeriParal[j+1][2], 0.0f);
			glEnd ();
		}
	}
	glPopMatrix();
}

// Draw the equatorial parallels
void AfficheParalleles(void)
{	glPushMatrix();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	float coef;
	coef=rand();
	coef/=RAND_MAX;
	glColor3f(0.2*coef+0.1,0.025*coef+0.1,0.025*coef+0.1);
	for(int i=0;i<18;i++)
	{	for(int j=0;j<50;j++)
		{	float r=cos((i-9)*PI/18);
			float h=sin((i-9)*PI/18)*20;
			glBegin (GL_LINES);
				glVertex3f(DmeriParal[j][1]*r,h,DmeriParal[j][2]*r);
				glVertex3f(DmeriParal[j+1][1]*r,h,DmeriParal[j+1][2]*r);
			glEnd ();
		}
	}
	glPopMatrix();
}

// Draw the azimuthal parallels
void AfficheParallelesAzimuth(void)
{	glPushMatrix();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	float coef;
	coef=rand();
	coef/=RAND_MAX;
	glColor3f(0.015*coef+0.1,0.12*coef+0.08,0.015*coef+0.1);
	for(int i=0;i<18;i++)
	{	for(int j=0;j<50;j++)
		{	float r=cos((i-9)*PI/18);
			float h=sin((i-9)*PI/18)*20;
			glBegin (GL_LINES);
				glVertex3f(DmeriParal[j][1]*r,h,DmeriParal[j][2]*r);
				glVertex3f(DmeriParal[j+1][1]*r,h,DmeriParal[j+1][2]*r);
			glEnd ();
		}
	}
	glPopMatrix();
}

// Draw the celestrial equator
void AfficheEquateurCeleste(void)
{	glPushMatrix();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	float coef;
	coef=rand();
	coef/=RAND_MAX;
	glColor3f(0.2*coef+0.3,0.025*coef+0.1,0.025*coef+0.1);
	for(int j=0;j<50;j++)
	{	glBegin (GL_LINES);
			glVertex3f(DmeriParal[j][1]*20,0,DmeriParal[j][2]*20);
			glVertex3f(DmeriParal[j+1][1]*20,0,DmeriParal[j+1][2]*20);
		glEnd ();
	}
	glPopMatrix();
}

// Draw the ecliptic line  !!!!  erreur !!!!!   revoir
void AfficheEcliptique(void)
{	glPushMatrix();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	float coef;
	coef=rand();
	coef/=RAND_MAX;
	glColor3f(0.025*coef+0.1,0.025*coef+0.1,0.025*coef+0.0);
	glRotatef(87.75f,0,1,0);
	glRotatef(23,0,0,1);
	for(int j=0;j<50;j++)
	{	glBegin (GL_LINES);
			glVertex3f(DmeriParal[j][1]*20,0,DmeriParal[j][2]*20);
			glVertex3f(DmeriParal[j+1][1]*20,0,DmeriParal[j+1][2]*20);
		glEnd ();
	}
	glPopMatrix();
}

// Draw the horizon fog
void AfficheHorizon(void)
{	glPushMatrix();
	glColor3f(0.1f+0.2f*coefciel, 0.15f+0.2f*coefciel, 0.15f+0.2f*coefciel);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBindTexture(GL_TEXTURE_2D, texIds[3]);
	glTranslatef(0,-20,0);
	glRotatef(-90,1,0,0);
	GLUquadricObj * Horizon=gluNewQuadric();
	gluQuadricTexture(Horizon,GL_TRUE);
	gluCylinder(Horizon,800,800,300,10,1);
	gluDeleteQuadric(Horizon);
	glPopMatrix();	
}

// Draw a point... (used for tests)
void AffichePoint(float X,float Y,float Z)
{		glColor3f(0.5, 1.0, 0.5);
		glDisable(GL_TEXTURE_2D);
		glEnable(GL_BLEND);
		glPointSize(5);
		glBegin(GL_POINTS);
			glVertex3f(X,Y,Z);
		glEnd();
}

// Draw the pointer
void AffichePointeur(vec3_t obj, vec3_t RGB)
{	double x,y;
	Projette(obj[0],obj[1],obj[2],x,y);
	setOrthographicProjection(winW, winH);
	glPushMatrix();
	glLoadIdentity();
	glColor3fv(RGB);
	glBindTexture (GL_TEXTURE_2D, texIds[12]);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glTranslatef(x, winH-y,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-10.0f,-10,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(10.0f,-10,0);		//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(10.0f,10,0);			//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-10.0f,10,0);		//Haut Gauche
	glEnd ();
	glPopMatrix();
	resetPerspectiveProjection();
}

// Draw the clikable menu
void AfficheMenu(void)
{	setOrthographicProjection(winW, winH);
	glPushMatrix();
	glLoadIdentity();
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);

	if (FlagConst) glColor3f(0.4,0.4,0.8); else glColor3f(0.12,0.12,0.40);	
	glBindTexture (GL_TEXTURE_2D, texIds[13]);
	glTranslatef(16, winH-16,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-16.0f,16,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(16.0f,16,0);			//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(16.0f,-16,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-16.0f,-16,0);		//Haut Gauche
	glEnd ();

	if (FlagNomConst) glColor3f(0.4,0.4,0.8); else glColor3f(0.12,0.12,0.40);	
	glBindTexture (GL_TEXTURE_2D, texIds[14]);
	glTranslatef(32,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-16.0f,16,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(16.0f,16,0);			//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(16.0f,-16,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-16.0f,-16,0);		//Haut Gauche
	glEnd ();

	if (FlagLignes) glColor3f(0.8,0.4,0.4);  else glColor3f(0.40,0.13,0.13);
	glBindTexture (GL_TEXTURE_2D, texIds[15]);
	glTranslatef(32,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-16.0f,16,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(16.0f,16,0);			//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(16.0f,-16,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-16.0f,-16,0);		//Haut Gauche
	glEnd ();

	if (FlagLignesAzimuth) glColor3f(0.32,0.46,0.32);  else glColor3f(0.08,0.2,0.08);
	glBindTexture (GL_TEXTURE_2D, texIds[15]);
	glTranslatef(32,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-16.0f,16,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(16.0f,16,0);			//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(16.0f,-16,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-16.0f,-16,0);		//Haut Gauche
	glEnd ();

	if (FlagCardinaux) glColor3f(0.8,0.4,0.4);  else glColor3f(0.40,0.13,0.13);
	glBindTexture (GL_TEXTURE_2D, texIds[20]);
	glTranslatef(32,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-16.0f,16,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(16.0f,16,0);			//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(16.0f,-16,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-16.0f,-16,0);		//Haut Gauche
	glEnd ();

	if (FlagSol) glColor3f(0.65,0.65,0.65);  else glColor3f(0.3,0.3,0.3);
	glBindTexture (GL_TEXTURE_2D, texIds[16]);
	glTranslatef(32,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-16.0f,16,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(16.0f,16,0);			//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(16.0f,-16,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-16.0f,-16,0);		//Haut Gauche
	glEnd ();

	if (FlagHorizon) glColor3f(0.55,0.55,0.55);  else glColor3f(0.2,0.2,0.2);
	glBindTexture (GL_TEXTURE_2D, texIds[19]);
	glTranslatef(32,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-16.0f,16,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(16.0f,16,0);			//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(16.0f,-16,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-16.0f,-16,0);		//Haut Gauche
	glEnd ();

	if (FlagCiel) glColor3f(0.5,0.5,0.5);  else glColor3f(0.2,0.2,0.2);
	glBindTexture (GL_TEXTURE_2D, texIds[21]);
	glTranslatef(32,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-16.0f,16,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(16.0f,16,0);			//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(16.0f,-16,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-16.0f,-16,0);		//Haut Gauche
	glEnd ();

	if (Flaganim) glColor3f(0.5,0.5,0.5);  else glColor3f(0.2,0.2,0.2);
	glBindTexture (GL_TEXTURE_2D, texIds[17]);
	glTranslatef(32,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-16.0f,16,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(16.0f,16,0);			//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(16.0f,-16,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-16.0f,-16,0);		//Haut Gauche
	glEnd ();

	if (Flaganimmin) glColor3f(0.5,0.5,0.5);  else glColor3f(0.2,0.2,0.2);
	glBindTexture (GL_TEXTURE_2D, texIds[18]);
	glTranslatef(32,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-16.0f,16,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(16.0f,16,0);			//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(16.0f,-16,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-16.0f,-16,0);		//Haut Gauche
	glEnd ();

	if (FlagTexte) glColor3f(0.1f,0.55f,0.6f);  else glColor3f(0.0f,0.2f,0.22f);
	glBindTexture (GL_TEXTURE_2D, texIds[22]);
	glTranslatef(32,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-16.0f,16,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(16.0f,16,0);			//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(16.0f,-16,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-16.0f,-16,0);		//Haut Gauche
	glEnd ();

	if (FlagHelp) glColor3f(0.1f,0.55f,0.6f);  else glColor3f(0.0f,0.2f,0.22f);
	glBindTexture (GL_TEXTURE_2D, texIds[23]);
	glTranslatef(32,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-16.0f,16,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(16.0f,16,0);			//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(16.0f,-16,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-16.0f,-16,0);		//Haut Gauche
	glEnd ();

	glPopMatrix();
	resetPerspectiveProjection();
}

// Draw the mountains with a few pieces of a big texture
void AfficheDecor(int nb)
{	glPushMatrix();
	glColor3f(0.05f+0.5f*coefciel, 0.08f+0.8f*coefciel, 0.05f+0.5f*coefciel);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);

	float delta=1.98915/nb; // environ egal  sin((float)(PI/8))/cos((float)(PI/8))*10/2;
	for (int ntex=0;ntex<4*nb;ntex++)
	{	glBindTexture(GL_TEXTURE_2D, texIds[31+ntex%4]);
		for (int nDecoupe=0;nDecoupe<4;nDecoupe++)
		{	glBegin(GL_QUADS );
				//Haut Gauche
				glTexCoord2f((float)nDecoupe/4,1.0f);		
				glVertex3f(10.0f,1.5f,-delta);
				//Bas Gauche
				glTexCoord2f((float)nDecoupe/4,0.0f);		
				glVertex3f(10.0f,-1.0f,-delta);
				//Bas Droit
				glTexCoord2f((float)nDecoupe/4+0.25,0.0f);
				glVertex3f(10.0f,-1.0f,delta);
				//Haut Droit
				glTexCoord2f((float)nDecoupe/4+0.25,1.0f);
				glVertex3f(10.0f,1.5f,delta);
			glEnd ();
			glRotatef(22.5/nb,0,-1,0);
		}
	}
	glPopMatrix();
}

// Draw the sky
void AfficheCiel(void)
{	glPushMatrix();	
	glColor3f(0.6f*coefciel, 0.6f*coefciel, 1.0f*coefciel);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBindTexture(GL_TEXTURE_2D, texIds[4]);

	glRotatef(-90,1,0,0);
	GLUquadricObj * Ciel=gluNewQuadric();
	gluQuadricTexture(Ciel,GL_TRUE);
	gluSphere(Ciel,10,20,20);
	gluDeleteQuadric(Ciel);
	glPopMatrix();
}

// Draw the ground
void AfficheSol(void)
{	glPushMatrix();
	glColor3f(0.08+0.6f*coefciel, 0.08+0.6f*coefciel, 0.15+0.7f*coefciel);
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glBindTexture(GL_TEXTURE_2D, texIds[1]);
	glBegin (GL_QUADS);
        glTexCoord2f (0.0f,0.0f);
        glVertex3f (-1000.0f, -5.0f, -1000.0f);
        glTexCoord2f (1.0f, 0.0f);
		glVertex3f(-1000.0f, -5.0f,  1000.0f);
        glTexCoord2f (1.0f, 1.0f);
		glVertex3f( 1000.0f, -5.0f,  1000.0f);
        glTexCoord2f (0.0f, 1.0f);
		glVertex3f( 1000.0f, -5.0f, -1000.0f);
    glEnd ();
	glPopMatrix();
}

// Print help screen
void AfficheHelp(void)
{	glColor3f(0.5f,0.5f,0.8f);
	int xt=winW/2-140,yt=(winH-430)/2;
	renderBitmapString(xt,yt,(void *)font,"4 Directions : Deplacement RA/DE");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"Page Up/Down : Zoom");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"Clic Gauche Souris : Selectionne Etoile");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"Clic Droit  Souris : Efface Pointeur");
	yt+=26;
	

	renderBitmapString(xt,yt,(void *)font,"H   : Aide");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"I   : Info");
	yt+=26;

	renderBitmapString(xt,yt,(void *)font,"K   : Dessins des Constellations");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"N   : Noms des Constellations");
	yt+=26;

	renderBitmapString(xt,yt,(void *)font,"L   : Grille Equatoriale");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"J   : Grille Azimuthale");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"A   : Points Cardinaux");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"R   : Ecliptique");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"F   : Equateur Celeste");
	yt+=26;

	renderBitmapString(xt,yt,(void *)font,"S   : Sol");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"Z   : Brume");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"C   : Ciel");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"+   : Ciel + lumineux");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"-   : Ciel - lumineux");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"E   : Etoiles");
	yt+=26;


	renderBitmapString(xt,yt,(void *)font,".   : Temps Reel");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"0   : Temps Accelere");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"T   : Texte");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"M   : Menu");
	yt+=26;

	renderBitmapString(xt,yt,(void *)font,"ESC : Quitte");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"F1  : Plein Ecran");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"F2  : En Fenetre");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"F3-F8 : Modes Fullscreen");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"F9  : Quitte Mode Fullscreen");
	yt+=13;
}

// Print info screen
void AfficheInfo(void)
{	glColor3f(0.8f,0.3f,0.3f);
	int xt=winW/2-140,yt=(winH-180)/2;
	renderBitmapString(xt,yt,(void *)font,"            Stellarium");
	yt+=26;
	renderBitmapString(xt,yt,(void *)font,"       Programme par Alioth");
	yt+=26;
	renderBitmapString(xt,yt,(void *)font,"            Avril 2001");
	yt+=26;
	renderBitmapString(xt,yt,(void *)font,"          chereau@free.fr");
	yt+=52;
	xt=winW/2-200;
	renderBitmapString(xt,yt,(void *)font,"Ce programme est gratuit mais si vous voulez vous");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"separer de votre argent, envoyez vos dons a :");
	yt+=26;
	renderBitmapString(xt,yt,(void *)font,"       Club Astronomie de l'INSA de Lyon");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"           20, Av. Albert Einstein");
	yt+=13;
	renderBitmapString(xt,yt,(void *)font,"          69621 Villeurbanne, FRANCE");
	yt+=13;
}
