// LesEtoiles.cpp: implementation of the LesEtoiles class.
//
//////////////////////////////////////////////////////////////////////

// class used to manage groups of Etoile

#define PI 3.14159265358979323846264338327950288419716939937510f
#include "LesEtoiles.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

LesEtoiles::LesEtoiles()
{
}

// Load from file ( create the stream and call the Lire function )
void LesEtoiles::Charger(char * NomFichier)
{	ifstream fic (NomFichier,ios::in);
	if (fic.is_open())
	{	Lire(fic);
		fic.close();
	}
}

// Destructor
LesEtoiles::~LesEtoiles()
{	vector<Etoile *>::iterator iter;
	for(iter=Liste.begin();iter!=Liste.end();iter++)
	{	delete (*iter);
	}
}

// read from stream
int LesEtoiles::Lire(ifstream & lestream)
{	cout << "Chargement des donnees etoiles..." << endl;
	for(int i=0;i<20000;i++)
	{	Etoile * e = new Etoile;
		(*e).Lire(lestream);
		if (lestream.eof())
		{	delete e;
			break;
		}
		Liste.push_back(e);
	}
	return 0;
}

// Draw all the stars
void LesEtoiles::Afficher(float MagLimite)
{	ChampPrecalc=((Ouv+4.)*PI*((double)winW/winH)/360.); // Precalc the field of view for optimizations
	glBindTexture (GL_TEXTURE_2D, texIds[0]);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	vector<Etoile *>::iterator iter;
	for(iter=Liste.begin();iter!=Liste.end();iter++)
	{	(**iter).Afficher(MagLimite);
	}
}

// Look for a star by RA/DE
int LesEtoiles::Rechercher(float RA,float DE)
{	vector<Etoile *>::iterator iter;
	Etoile * plusProche;
	float distPlusProche=100;
	float distRa,distDe;
	for(iter=Liste.begin();iter!=Liste.end();iter++)
	{	distDe=(**iter).DecRad-DE;
		distRa=(**iter).RaRad-RA;
		if (sqrt(distDe*distDe+distRa*distRa)<distPlusProche)
		{	distPlusProche=sqrt(distDe*distDe+distRa*distRa);
			plusProche=(*iter);
		}
	}
	//printf("PlusProche : Nom:%s HR:%i RA:%4.2f DE:%4.2f Dist:%4.5f\n",&(*plusProche).Name,(*plusProche).HR,(*plusProche).RaRad*12/3.141,(*plusProche).DecRad*180/3.141,distPlusProche);
	if (distPlusProche<1) 
	{	Selectionnee=plusProche;
		return 0;
	}
	else return 1;
}

// Look for a star by Harvard Revised Catalog number
Etoile * LesEtoiles::Rechercher(unsigned int HR)
{return Liste[HR-1];
}
