#include "utilitaires.h"
#include <stdio.h>

float RA_en_Rad(int RAh, int RAm, float RAs)
{	return (float)RAh*2*PI/24+(float)RAm*(2*PI/24)/60+RAs*((2*PI/24)/60)/60;
}

float DE_en_Rad(bool DEsign,int Deg, int Arcmin, int Arcsec)
{	float tps=(float)Deg*PI/180+(float)Arcmin*(PI/180)/60+(float)Arcsec*((PI/180)/60)/60;
	if (DEsign) return -1*tps; else return tps;
} 

void RA_en_hms(int & RAh, int & RAm, float & RAs, float RA)
{	RAh=(int)(RA*12/PI);
	RAm=(int)(RA*720/PI-RAh*60);
	RAs=RA*43200/PI-RAm*60-RAh*3600;
}

void Equ_to_altAz(vec3_t &leVect, float raZen, float deZen)
{	leVect.RotateY(raZen);
	leVect.RotateX(Astro::PI_OVER_TWO-deZen);
}

void AltAz_to_equ(vec3_t &leVect, float raZen, float deZen)
{	leVect.RotateX(deZen - Astro::PI_OVER_TWO);
	leVect.RotateY(-raZen);
}

// Calc the x,y coord on the screen with the X,Y and Z pos
void Projette(float objx_i,float objy_i,float objz_i,double & x ,double & y)
{	double z;
	glColor3f(0.5, 1.0, 0.5);
	GLdouble M[16];
	GLdouble P[16];
	GLint V[4];
	glGetDoublev(GL_MODELVIEW_MATRIX,M);
	glGetDoublev(GL_PROJECTION_MATRIX,P);
	glGetIntegerv(GL_VIEWPORT,V);
	gluProject(objx_i,objy_i,objz_i,M,P,V,&x,&y,&z);
}

// For text printing
void setOrthographicProjection(int w, int h)
{	glMatrixMode(GL_PROJECTION);	// switch to projection mode
	glPushMatrix();					// save previous matrix which contains the settings for the perspective projection
	glLoadIdentity();				// reset matrix
	gluOrtho2D(0, w, 0, h);			// set a 2D orthographic projection
	glScalef(1, -1, 1);				// invert the y axis, down is positive
	glTranslatef(0, -h, 0);			// mover the origin from the bottom left corner to the upper left corner
	glMatrixMode(GL_MODELVIEW);
}

void resetPerspectiveProjection() 
{	glMatrixMode(GL_PROJECTION);	// set the current matrix to GL_PROJECTION
	glPopMatrix();					// restore previous settings
	glMatrixMode(GL_MODELVIEW);		// get back to GL_MODELVIEW matrix
}

void renderBitmapString(float x, float y, void *font,char *string)
{	char *c;
	glRasterPos2f(x, y);			// set position to start drawing fonts
	for (c=string; *c != '\0'; c++) // loop all the characters in the string
	{	glutBitmapCharacter(font, *c);
	}
}

void RADE_to_XYZ(float RA, float DE, vec3_t &XYZ)
{	const double cosLat = cos( DE );
	XYZ[0] = sin( RA ) * cosLat;
	XYZ[1] = sin( DE );
	XYZ[2] = cos( RA ) * cosLat;
}

void XYZ_to_RADE(float &RA, float &DE, vec3_t XYZ)
{	float xz_dist = (float)sqrt(XYZ[0]*XYZ[0]+XYZ[2]*XYZ[2]);
	DE = (float)atan2(XYZ[1],xz_dist);
	RA = (float)atan2(XYZ[0],XYZ[2]);
	RA=AstroOps::normalizeRadians(RA);
}